<%@ page contentType="application/json" %>
<%@ page import="java.util.*" %>
<%@ page import="java.net.*" %>
<%
response.setContentType("application/json");

String availableLocales = request.getParameter("availableLocales");
String userLocale = request.getParameter("userLocale");
String[] locales = availableLocales.split(",");

String[] localeTokens = userLocale.split("-");
String userLanguage = null;
String userCountry = null;
if (localeTokens.length > 1) {
	userLanguage = localeTokens[0];
	userCountry = localeTokens[1].toUpperCase();
} else {
	userLanguage = localeTokens[0]; 
}

java.util.Locale newLocale = null;
if (userCountry == null) {
	newLocale = new java.util.Locale(userLanguage);
} else {
	newLocale = new java.util.Locale(userLanguage, userCountry);
}

String translatedLocales = "{";
for (int i=0; i<locales.length; i++) {
	// Exclude the IW locale (which is the same as HE) and ROOT which resolves to EN for Dojo
	if (!locales[i].equals("iw") && !locales[i].equals("ROOT")) {
		localeTokens = locales[i].split("-");
		String language = null;
		String country = null;
		if (localeTokens.length > 1) {
			language = localeTokens[0];
			country = localeTokens[1];
		} else {
			language = localeTokens[0]; 
		}
		
		java.util.Locale locale = null;
		if (country == null) {
			locale = new java.util.Locale(language);
		} else {
			locale = new java.util.Locale(language, country);
		}
		
		if (!translatedLocales.equals("{")) {
			translatedLocales += ",";
		}
		
		// This now returns the language name in the native of the language. (IE, Deutsch, not "German")
		// It used to return the language name in the style of the current setting (IE, German)
		// but it is easier for users to find their own language in their own language's proper name
		// plus, the JDK doesn't have the correct translations for all languages DisplayName()
		translatedLocales += "\"" + locales[i] + "\":\"" + locale.getDisplayName(locale) + "\"";
	}
}
translatedLocales += "}";
//translatedLocales = URLEncoder.encode(translatedLocales,"UTF-8");
%>
<%=translatedLocales%>
