<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="java.util.List"%>
<%@ page import="com.lombardisoftware.client.persistence.common.ID"%>
<%@ page import="com.lombardisoftware.client.persistence.common.POType"%>
<%@ page import="com.lombardisoftware.psapi.data.User"%>
<%@ page import="com.lombardisoftware.client.delegate.UserGroupAPIFacadeDelegateFactory"%>
<%@ page import="com.lombardisoftware.client.delegate.SecurityDelegateFactory"%>
<%@ page import="com.lombardisoftware.client.persistence.common.ID"%>
<%@ page import="com.lombardisoftware.client.persistence.common.POType"%>
<%@ page import="com.lombardisoftware.client.persistence.common.LegacyIDHelper"%>
<%@ page import="java.util.Map"%>

<!-- BEGIN #content -->

<% 
    String portalcontextroot = request.getParameter("portalcontextroot");
    String userLocale = null;
%>

<html class="processPortal">
  <head>
    <title id="dashboard_restart_title"></title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  </head>
  <LINK REL="stylesheet" HREF="/mum/mycontenthandler/mm/dav/filestore/public/themes/processPortalTheme/theme.css" TYPE="text/css">
  <p id="dashboard_finished_message"></p>
  <p><button id="dashboard_restart_button" name="restart" type="button" class="bpm-task-inline-blue-button" onClick="restartDashboard();"></button>
  	<script type="text/javascript" src="/portal/js/dojo/1.6.1/dojo/dojo.js"
		djConfig="parseOnLoad:true">
	</script>
    <script>
    dojo.require("dojo.cookie");
    dojo.addOnLoad(function(){
    <%
    	com.lombardisoftware.psapi.data.User rawUser = UserGroupAPIFacadeDelegateFactory.getInstance().newInstance().getCurrentUser();
    	
    	// User Preference Data    	
    	ID<POType.User> id = LegacyIDHelper.fromLong(POType.User, rawUser.getUserID());
    	Map<String, String> attrData = SecurityDelegateFactory.getInstance().newInstance().getUserAttributes(id);
    	if (attrData != null) {
    		userLocale = attrData.get("Locale");
    	} else {
    	}    
    %>
    var locale = '<%=userLocale%>';
    console.log("userLocale: "+locale);
    var pcr = '<%=portalcontextroot%>';
    dojo.registerModulePath("com.ibm.bpm.social", "/"+pcr+"/com/ibm/bpm/social");
	var messages = null;
    if (locale) {
        dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial", locale);
        messages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial", locale);
    } else {
        dojo.requireLocalization("com.ibm.bpm.social", "bpmSocial");
        messages = dojo.i18n.getLocalization("com.ibm.bpm.social", "bpmSocial");
    }

    // Update the cookie to indicate we are now at restartDashboard
    var cookie = dojo.fromJson(dojo.cookie("restartDashboardCookie"));
    var lastDashboardURL = cookie.lastDashboardURL;
    for (var i = 0; i < cookie.dashboards.length; i++) {
        var cur = cookie.dashboards[i];
        if (cur.dashboardURL === lastDashboardURL) {
            cur.atRestartDashboard = true;
        }
    }
    dojo.cookie("restartDashboardCookie", dojo.toJson(cookie), {expires:1, path:'/'});

    if(navigator.appName == 'Microsoft Internet Explorer') {
        dojo.byId("dashboard_restart_title").title = messages.dashboard_restart_title;
        dojo.byId("dashboard_finished_message").innerHTML = messages.dashboard_finished_message;
        dojo.byId("dashboard_restart_button").innerHTML = messages.dashboard_restart_button;
        // if we are in a frame do not close as this would close the whole window
        try {
            if(window.frameElement === null) {
                // Closing window for IE without confirmation message box
                window.opener='whatever';
                window.open('','_parent','');
                window.close();
            }
        } catch (e) {
            // we are in a frame, but the parent window has a different domain -> Permission denied
        }
    } else {
        dojo.byId("dashboard_restart_title").innerHTML = messages.dashboard_restart_title;
        dojo.byId("dashboard_finished_message").innerHTML = messages.dashboard_finished_message;
        dojo.byId("dashboard_restart_button").innerHTML = messages.dashboard_restart_button;
        // other browsers by design do not allow to close window objects not opened using window.open()
        self.close();
    }

    
    })
  </script>
  <script language="JavaScript">
    
    function restartDashboard() {
			var event = {
				"name": "onDashboardRestart",
				"taskID" : null,
				"applicationInstanceId" : null,
				"parameters": []
			};
	    window.parent.postMessage(dojo.toJson(event), "*");
    }

  </script>
</html>
